﻿Imports System.Threading
Imports System.ComponentModel

Public Class DAEnetIP3_Demo
    Dim buffLen As Integer
    Delegate Sub SetTextCallback(ByVal text As String)
    Dim strCurrCommand As String


    Private Sub SetSingleRelay(ByVal RelayN As String, ByRef State As Boolean)
        Dim Command As String

        Try
            If (cbDOAtATime.Checked = False) Then
                If (State = True) Then
                    Command = tfSerAddr.Text + "AS" + RelayN + "=1;"
                Else
                    Command = tfSerAddr.Text + "AS" + RelayN + "=0;"
                End If
                SerialPort1.Write(Command)
                rtLog.AppendText("Send: " + Command + vbCrLf)
                Thread.Sleep(100) 'Ensure that there will be some delay between two commands and they won't be accepted as one sequence that will return error

            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub setAllRelays()
        Dim byte1 As Byte
        Dim byte2 As Byte
        Dim strDOF8 As String
        Dim strDO70 As String

        Dim Command As String

        byte1 = 0
        byte2 = 0
        If cbDO7.Checked = True Then byte1 = byte1 Or 128 Else byte1 = byte1 And 127
        If cbDO6.Checked = True Then byte1 = byte1 Or 64 Else byte1 = byte1 And 191
        If cbDO5.Checked = True Then byte1 = byte1 Or 32 Else byte1 = byte1 And 223
        If cbDO4.Checked = True Then byte1 = byte1 Or 16 Else byte1 = byte1 And 239
        If cbDO3.Checked = True Then byte1 = byte1 Or 8 Else byte1 = byte1 And 247
        If cbDO2.Checked = True Then byte1 = byte1 Or 4 Else byte1 = byte1 And 251
        If cbDO1.Checked = True Then byte1 = byte1 Or 2 Else byte1 = byte1 And 253
        If cbDO0.Checked = True Then byte1 = byte1 Or 1 Else byte1 = byte1 And 254


        If cbDO15.Checked = True Then byte2 = byte2 Or 128 Else byte2 = byte2 And 127
        If cbDO14.Checked = True Then byte2 = byte2 Or 64 Else byte2 = byte2 And 191
        If cbDO13.Checked = True Then byte2 = byte2 Or 32 Else byte2 = byte2 And 223
        If cbDO12.Checked = True Then byte2 = byte2 Or 16 Else byte2 = byte2 And 239
        If cbDO11.Checked = True Then byte2 = byte2 Or 8 Else byte2 = byte2 And 247
        If cbDO10.Checked = True Then byte2 = byte2 Or 4 Else byte2 = byte2 And 251
        If cbDO9.Checked = True Then byte2 = byte2 Or 2 Else byte2 = byte2 And 253
        If cbDO8.Checked = True Then byte2 = byte2 Or 1 Else byte2 = byte2 And 254

        strDO70 = Hex(byte1)
        If byte1 < 16 Then strDO70 = "0" + strDO70
        strDOF8 = Hex(byte2)
        If byte2 < 16 Then strDOF8 = "0" + strDOF8

        Command = tfSerAddr.Text + "ASG=" + strDOF8 + strDO70 + ";"


        rtLog.AppendText("Send: " + Command + vbCrLf)
        SerialPort1.Write(Command)
        Thread.Sleep(100) 'Ensure that there will be some delay between two commands and they won't be accepted as one sequence that will return error

    End Sub

    Private Sub GetAI()
        Dim Command As String
        Try
            For i As Integer = 0 To 7
                Command = tfSerAddr.Text + "CV" + Mid(Str(i), 2, 1) + "=?;"
                SerialPort1.Write(Command)
                rtLog.AppendText("Send: " + Command + vbCrLf)
                Thread.Sleep(100) 'Ensure that there will be some delay between two commands and they won't be accepted as one sequence that will return error
            Next i

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub GetDI()
        Dim Command As String
        Command = tfSerAddr.Text + "BVG=?;"
        SerialPort1.Write(Command)
        rtLog.AppendText("Send: " + Command + vbCrLf)
        Thread.Sleep(100) 'Ensure that there will be some delay between two commands and they won't be accepted as one sequence that will return error
    End Sub

    Private Sub GetDO()
        Dim Command As String
        Command = tfSerAddr.Text + "ASG=?;"
        SerialPort1.Write(Command)
        rtLog.AppendText("Send: " + Command + vbCrLf)
        Thread.Sleep(100) 'Ensure that there will be some delay between two commands and they won't be accepted as one sequence that will return error

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Try
            SerialPort1.PortName = tfComName.Text
            SerialPort1.BaudRate = Val(tfComBaud.Text)
            SerialPort1.Open()
            rtLog.AppendText("Com Port opened" + vbCrLf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub



    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO0.CheckedChanged
        SetSingleRelay("0", cbDO0.Checked)
    End Sub

    Private Sub cbDO1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO1.CheckedChanged
        SetSingleRelay("1", cbDO1.Checked)
    End Sub

    Private Sub cbDO2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO2.CheckedChanged
        SetSingleRelay("2", cbDO2.Checked)
    End Sub

    Private Sub cbDO3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO3.CheckedChanged
        SetSingleRelay("3", cbDO3.Checked)
    End Sub

    Private Sub cbDO4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO4.CheckedChanged
        SetSingleRelay("4", cbDO4.Checked)
    End Sub

    Private Sub cbDO5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO5.CheckedChanged
        SetSingleRelay("5", cbDO5.Checked)
    End Sub

    Private Sub cbDO6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO6.CheckedChanged
        SetSingleRelay("6", cbDO6.Checked)
    End Sub

    Private Sub cbDO7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO7.CheckedChanged
        SetSingleRelay("7", cbDO7.Checked)
    End Sub

    Private Sub cbDO8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO8.CheckedChanged
        SetSingleRelay("8", cbDO8.Checked)
    End Sub

    Private Sub cbDO9_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO9.CheckedChanged
        SetSingleRelay("9", cbDO9.Checked)
    End Sub

    Private Sub cbDO10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO10.CheckedChanged
        SetSingleRelay("A", cbDO10.Checked)
    End Sub

    Private Sub cbDO11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO11.CheckedChanged
        SetSingleRelay("B", cbDO11.Checked)
    End Sub

    Private Sub cbDO012_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO12.CheckedChanged
        SetSingleRelay("C", cbDO12.Checked)
    End Sub

    Private Sub cbDO13_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO13.CheckedChanged
        SetSingleRelay("D", cbDO13.Checked)
    End Sub

    Private Sub cbDO14_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO14.CheckedChanged
        SetSingleRelay("E", cbDO14.Checked)
    End Sub

    Private Sub cbDO15_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbDO15.CheckedChanged
        SetSingleRelay("F", cbDO15.Checked)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        rtLog.Clear()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Label15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles labAinVal5.Click

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        GetDO()
    End Sub

    Private Sub bnSetDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSetDO.Click
        If cbDOAtATime.Checked = True Then
            setAllRelays()
        End If

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim strNext As String
        Dim strExecuteCommand As String
        Dim i As Integer

        i = 1
        strExecuteCommand = ""
        strCurrCommand = strCurrCommand + SerialPort1.ReadExisting
        ''strCurrCommand = "00CV0=123;00CV1=111;00CV2=123;"
        While InStr(strCurrCommand, ";") > 0
            strNext = Mid(strCurrCommand, i, 1)
            strExecuteCommand = strExecuteCommand + strNext
            If strNext = ";" Then
                ProcessCommand(strExecuteCommand)
                strCurrCommand = strCurrCommand.Remove(0, Len(strExecuteCommand))
                i = i - Len(strExecuteCommand)
                strExecuteCommand = ""
            End If
            i = i + 1

        End While

    End Sub


    Private Sub ProcessCommand(ByVal [text] As String)
        If Me.rtLog.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf ProcessCommand)
            Me.Invoke(d, New Object() {[text]})
        Else
            Dim txtRcv As String
            Dim Value As String
            txtRcv = [text]

            If (Mid(txtRcv, 3, 1) = "C") Then 'Receiving Analog Input Value
                If (cbVin.Checked = True) Then
                    Value = Mid(txtRcv, 7, Len(txtRcv) - 7)
                    Value = Str((Val(Value) * Val(cmbVinRange.SelectedItem.ToString)) / 1023)
                Else
                    Value = Mid(txtRcv, 7, Len(txtRcv) - 7)
                End If

                Select Case (Val(Mid(txtRcv, 5, 1)))
                    Case 0
                        pbAin0.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal0.Text = Value

                    Case 1
                        pbAin1.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal1.Text = Value

                    Case 2
                        pbAin2.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal2.Text = Value

                    Case 3
                        pbAin3.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal3.Text = Value

                    Case 4
                        pbAin4.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal4.Text = Value

                    Case 5
                        pbAin5.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal5.Text = Value

                    Case 6
                        pbAin6.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal6.Text = Value

                    Case 7
                        pbAin7.Value = Val(Mid(txtRcv, 7, Len(txtRcv) - 7))
                        labAinVal7.Text = Value

                End Select
            End If

            If (Mid(txtRcv, 3, 3) = "BVG") Then 'Receiving Digital Input Value
                Dim HexVal As Byte
                Value = Mid(txtRcv, 7, Len(txtRcv) - 7)
                HexVal = Val("&H" + Value)
                If (HexVal And 128) = 0 Then cbDI7.Checked = False Else cbDI7.Checked = True
                If (HexVal And 64) = 0 Then cbDI6.Checked = False Else cbDI6.Checked = True
                If (HexVal And 32) = 0 Then cbDI5.Checked = False Else cbDI5.Checked = True
                If (HexVal And 16) = 0 Then cbDI4.Checked = False Else cbDI4.Checked = True
                If (HexVal And 8) = 0 Then cbDI3.Checked = False Else cbDI3.Checked = True
                If (HexVal And 4) = 0 Then cbDI2.Checked = False Else cbDI2.Checked = True
                If (HexVal And 2) = 0 Then cbDI1.Checked = False Else cbDI1.Checked = True
                If (HexVal And 1) = 0 Then cbDI0.Checked = False Else cbDI0.Checked = True
            End If

            If (Mid(txtRcv, 3, 3) = "ASG") Then 'Receiving Digital Input Value
                Dim HexVal As Byte
                Value = Mid(txtRcv, 7, Len(txtRcv) - 7)
                HexVal = Val("&H" + Mid(Value, 3, 2))
                If (HexVal And 128) = 0 Then cbDOState7.Checked = False Else cbDOState7.Checked = True
                If (HexVal And 64) = 0 Then cbDOState6.Checked = False Else cbDOState6.Checked = True
                If (HexVal And 32) = 0 Then cbDOState5.Checked = False Else cbDOState5.Checked = True
                If (HexVal And 16) = 0 Then cbDOState4.Checked = False Else cbDOState4.Checked = True
                If (HexVal And 8) = 0 Then cbDOState3.Checked = False Else cbDOState3.Checked = True
                If (HexVal And 4) = 0 Then cbDOState2.Checked = False Else cbDOState2.Checked = True
                If (HexVal And 2) = 0 Then cbDOState1.Checked = False Else cbDOState1.Checked = True
                If (HexVal And 1) = 0 Then cbDOState0.Checked = False Else cbDOState0.Checked = True

                Value = Mid(txtRcv, 7, Len(txtRcv) - 7)
                HexVal = Val("&H" + Mid(Value, 1, 2))
                If (HexVal And 128) = 0 Then cbDOState15.Checked = False Else cbDOState15.Checked = True
                If (HexVal And 64) = 0 Then cbDOState14.Checked = False Else cbDOState14.Checked = True
                If (HexVal And 32) = 0 Then cbDOState13.Checked = False Else cbDOState13.Checked = True
                If (HexVal And 16) = 0 Then cbDOState12.Checked = False Else cbDOState12.Checked = True
                If (HexVal And 8) = 0 Then cbDOState11.Checked = False Else cbDOState11.Checked = True
                If (HexVal And 4) = 0 Then cbDOState10.Checked = False Else cbDOState10.Checked = True
                If (HexVal And 2) = 0 Then cbDOState9.Checked = False Else cbDOState9.Checked = True
                If (HexVal And 1) = 0 Then cbDOState8.Checked = False Else cbDOState8.Checked = True

            End If

            Me.rtLog.AppendText("Received: " + txtRcv + vbCrLf)
        End If
    End Sub


    Private Sub DAEnetIP3_Demo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initialization
        strCurrCommand = ""
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Try
            SerialPort1.Close()
            rtLog.AppendText("Com Port closed" + vbCrLf)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub DAEnetIP3_Demo_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        SerialPort1.Close()

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        GetDI()
    End Sub

    Private Sub btnGetAin0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetAin0.Click
        GetAI()
    End Sub
End Class
